//
//  type_general.h
//  dtbca_public_release
//
//  Created by Dhruv Batra on 8/25/11.
//  Copyright 2011 Dhruv Batra. All rights reserved.
//
//  Inspired by Vladimir Kolmogorov's typeGeneral.h in TRW-S

#ifndef __TYPE_GENERAL_H__
#define __TYPE_GENERAL_H__

#include <iostream>
#include <fstream>

#include "utils.h"
#include "constants_declaration.h"
#include "mrf_energy.h"

// Class that holds Data (graph, node and edge potentials) for a General MRF
// where nodes can have different cardinalities and general (non-potts) potentials
class TypeGeneral : public PairwiseEnergy
{
public:
    /////////////////////////////////////////////////////////
    // Data
    Labeltype* cardinalities;
    Labeltype sum_of_edge_potential_sizes;
            
    /////////////////////////////////////////////////////////
    // Functions

    // Constructor
    TypeGeneral():
    cardinalities(NULL),
    sum_of_edge_potential_sizes(0)
    { }
    
    // Destructor
    ~TypeGeneral()
    {    
        if (cardinalities)
        delete [] cardinalities;
    }
    
    
    void LoadEnergyFromFile(char *fname);
    void RoundEnergy();

};


#endif